/**
 * @Desc: 二维码处理
 * @Author: Ouyang Jeff (1014466231@qq.com)
 * @CreateTime: 2021-2-6 18:11:08
 * @Last Modified by: Ouyang Jeff (1014466231@qq.com)
 * @Last Modified time: 2021-2-6 18:11:08
 **/
(function ($) {
	var that;
    var Qrcode = function (eleId, callback) {
        this.eleId = eleId;
        this.callback = callback;
        var _this_ = this;
		that = this;
        var isWeiboWebView = /__weibo__/.test(navigator.userAgent);

        if (isWeiboWebView) {
            if (window.WeiboJSBridge) {
                _this_.bridgeReady(tempBtn);
            } else {
                document.addEventListener('WeiboJSBridgeReady', function () {
                    _this_.bridgeReady(tempBtn);
                });
            }
        } else {
            _this_.nativeReady();
        }
    };

    Qrcode.prototype = {
        nativeReady: function () {
            $("#" + this.eleId).bind("change", {eleId: this.eleId}, this.getImgFile);
        },
        getImgFile: function (event) {
            var eleId = event.data.eleId;
            var imgFile = $("#" + eleId)[0].files;
			if(imgFile.length) {
				var oFile = imgFile[0];
				var oFReader = new FileReader();
				var rFilter = /^(?:image\/bmp|image\/cis\-cod|image\/gif|image\/ief|image\/jpeg|image\/jpeg|image\/jpeg|image\/pipeg|image\/png|image\/svg\+xml|image\/tiff|image\/x\-cmu\-raster|image\/x\-cmx|image\/x\-icon|image\/x\-portable\-anymap|image\/x\-portable\-bitmap|image\/x\-portable\-graymap|image\/x\-portable\-pixmap|image\/x\-rgb|image\/x\-xbitmap|image\/x\-xpixmap|image\/x\-xwindowdump)$/i;

				if (imgFile.length === 0) {
					return;
				}

				if (!rFilter.test(oFile.type)) {
					alert("选择正确的图片格式!");
					return;
				}

				oFReader.onload = function (oFREvent) {
					qrcode.decode(oFREvent.target.result);
					qrcode.callback = that.callback;
				};

				oFReader.readAsDataURL(oFile);
			}
        },
        destory: function () {
            $("#" + this.eleId).off('click');
        }
    };
    window.Qrcode = Qrcode;
})(window.Zepto ? Zepto : jQuery);
