/**
 * @Desc: 工具包——不依赖jquery！！！
 * @Author: Ouyang Jeff (1014466231@qq.com)
 * @CreateTime: 2021-2-6 13:04:27
 * @Last Modified by: Ouyang Jeff (1014466231@qq.com)
 * @Last Modified time: 2021-2-6 13:04:27
 **/

// 获取appType
function getApptype() {
	// return localStorage.getItem("appType") || 1;
	return 1;
}

// 获取appId
function getAppId() {
	return localStorage.getItem("appid");
}

// todo 获取版本号——后续需要移出，集中到配置文件中
function getVersion() {
	return "1.7.0";
}

//去抖动函数——延迟响应，只提交最后一次
function debounce(method, context) {
	let last;
	return function() {
		let context = this,
			args = arguments;
		clearTimeout(last);
		last = setTimeout(function() {
			method.apply(context, args);
		}, context);
	}
}
//节流函数——一个时间段内只响应最后一次，有规律的重复执行
function throttle(func, delay) {
	let last = 0;
	return function() {
		let curr = +new Date();
		if (curr - last > delay) {
			func.apply(this, arguments);
			last = curr;
		}
	}
}

// 获取路径参数
function getParameter(param) {
	param = param || "";
	var reg_url = /^[^\?]+\?([\w\W]+)$/,
		reg_para = /([^&=]+)=([\w\W]*?)(&|$|#)/g,
		arr_url = reg_url.exec(window.location.href),
		ret = {};
	if (arr_url && arr_url[1]) {
		var str_para = arr_url[1],
			result;
		while ((result = reg_para.exec(str_para)) != null) {
			ret[result[1]] = result[2];
		}
	}
	return param ? (ret[param] || "") : ret;
}

// 设置页面参数
function setPageParams(dataId) {
	var appid = localStorage.getItem("appid") || "";
	if (dataId.indexOf("{") > -1) {
		dataId = getParameter("appid");
	}
	if (!appid || (appid != dataId)) {
		localStorage.setItem("appid", dataId);
	}
}

// 查验手机号
function checkPhone(phone) {
	return /^1[3456789]\d{9}$/.test(phone);
}
//去除字符串的所有空格
function clearSpace(str,isoff){
	if(!isoff){
		return str.replace(/\s*/g,"");
	}else {
		return str.replace(/^\s*|\s*$/g,"");
	}
}
/**
 *  对于ID卡号进行验证
 *  0 为 验证身份证
 *  2 为 验证港澳台通行证
 *  3 为 验证护照
 **/
function checkCardIdBySelectType(arg0, arg1) {
	// return true;// todo 时间关系，暂未找到正确的校验规则，跟后端校验保持一致
	var reg =
		/(^[1-9]\d{5}(18|19|([23]\d))\d{2}((0[1-9])|(10|11|12))(([0-2][1-9])|10|20|30|31)\d{3}[0-9Xx]$)|(^[1-9]\d{5}\d{2}((0[1-9])|(10|11|12))(([0-2][1-9])|10|20|30|31)\d{2}[0-9Xx]$)/;
	if (arg0 != null && arg0 != '' && typeof arg0 != "undefined") {
		if ('1' == arg0) { //如果是做身份证校验
			if ("888888888888888888" == arg1) return true;
			reg =
				/(^[1-9]\d{5}(18|19|([23]\d))\d{2}((0[1-9])|(10|11|12))(([0-2][1-9])|10|20|30|31)\d{3}[0-9Xx]$)|(^[1-9]\d{5}\d{2}((0[1-9])|(10|11|12))(([0-2][1-9])|10|20|30|31)\d{2}[0-9Xx]$)/;
			return reg.test(arg1);
		}
		// else if('1' == arg0){ //如果是军官证校验
		//     reg =  /^[a-zA-Z0-9]{7,21}$/;
		//     return reg.test(arg1);
		// }
		else if ('2' == arg0) { //如果是港澳台同行证
			return true; // todo 时间关系，暂未找到适用的港澳台校验规则，跟后端校验保持一致
			reg = /^([A-Z]\d{6,10}(\(\w{1}\))?)$/;
			var b = reg.test(arg1);
			if (!b) {
				reg = /^\d{8}|^[a-zA-Z0-9]{10}|^\d{18}$/; //台湾通行证
				return reg.test(arg1);
			} else {
				return true;
			}
		} else if ('3' == arg0) { //如果是护照
			return true; // todo 时间关系，暂未找到适用的港澳台校验规则，跟后端校验保持一致
			reg = /^([a-zA-z]|[0-9]){5,17}$/;
			return reg.test(arg1);
		}
	}
	return false;
}

//身份证效验方法
function checkIdCard(arg0,idcard) {
	var msg = "";
	switch(parseInt(arg0)) {
		// 居民身份证
		case IDENTITY_TYPE_IDCARD:
			var Errors = new Array("", "请输入18位身份证号码!", "身份证号码出生日期超出范围或含有非法字符!", "身份证号码校验错误!", "身份证地区非法!");
			var area = {
				11: "北京",
				12: "天津",
				13: "河北",
				14: "山西",
				15: "内蒙古",
				21: "辽宁",
				22: "吉林",
				23: "黑龙江",
				31: "上海",
				32: "江苏",
				33: "浙江",
				34: "安徽",
				35: "福建",
				36: "江西",
				37: "山东",
				41: "河南",
				42: "湖北",
				43: "湖南",
				44: "广东",
				45: "广西",
				46: "海南",
				50: "重庆",
				51: "四川",
				52: "贵州",
				53: "云南",
				54: "西藏",
				61: "陕西",
				62: "甘肃",
				63: "青海",
				64: "宁夏",
				65: "新疆",
				71: "台湾",
				81: "香港",
				82: "澳门",
				91: "国外"
			}
			var retflag = false;
			var idcard, Y, JYM;
			var S, M;
			var reg;
			var idcard_array = new Array();
			idcard_array = idcard.split("");
			//地区检验
			if (area[parseInt(idcard.substr(0, 2))] == null) msg = Errors[4];
			//身份号码位数及格式检验
			switch (idcard.length) {
				case 15:
					if ((parseInt(idcard.substr(6, 2)) + 1900) % 4 == 0 || ((parseInt(idcard.substr(6, 2)) + 1900) % 100 == 0 && (parseInt(idcard.substr(6, 2)) + 1900) % 4 == 0)) {
						ereg = /^[1-9][0-9]{5}19[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}$/; //测试出生日期的合法性
					} else {
						ereg = /^[1-9][0-9]{5}19[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))[0-9]{3}$/; //测试出生日期的合法性
					}
					if (ereg.test(idcard)) {
						msg = Errors[0];
					}
					else {
						msg = Errors[2];
					}
					break;
				case 18:
					if (parseInt(idcard.substr(6, 4)) % 4 == 0 || (parseInt(idcard.substr(6, 4)) % 100 == 0 && parseInt(idcard.substr(6, 4)) % 4 == 0)) {
						ereg = /^[1-9][0-9]{5}(19|20)[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}[0-9Xx]$/; //闰年出生日期的合法性正则表达式
					} else {
						ereg = /^[1-9][0-9]{5}(19|20)[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))[0-9]{3}[0-9Xx]$/; //平年出生日期的合法性正则表达式
					}
					if (ereg.test(idcard)) { //测试出生日期的合法性
						//计算校验位
						S = (parseInt(idcard_array[0]) + parseInt(idcard_array[10])) * 7 + (parseInt(idcard_array[1]) + parseInt(idcard_array[11])) * 9 + (parseInt(idcard_array[2]) + parseInt(idcard_array[12])) * 10 + (parseInt(idcard_array[3]) + parseInt(idcard_array[13])) * 5 + (parseInt(idcard_array[4]) + parseInt(idcard_array[14])) * 8 + (parseInt(idcard_array[5]) + parseInt(idcard_array[15])) * 4 + (parseInt(idcard_array[6]) + parseInt(idcard_array[16])) * 2 + parseInt(idcard_array[7]) * 1 + parseInt(idcard_array[8]) * 6 + parseInt(idcard_array[9]) * 3;
						Y = S % 11;

						M = "F";

						JYM = "10X98765432";
						M = JYM.substr(Y, 1); //判断校验位
						if (M == idcard_array[17]) msg = Errors[0]; //检测ID的校验位
						else {
							msg = Errors[3];
						}
					} else {
						msg = Errors[2];
					}
					break;
				default:
					msg = Errors[1];
					break;
			}
			break;
		// 护照
		case IDENTITY_TYPE_PASSPORT:
			// msg = ""; // todo 时间关系，暂未找到适用的港澳台校验规则，跟后端校验保持一致
			// reg = /^([a-zA-z]|[0-9]){5,17}$/;
			// msg = reg.test(idcard) ? "" : "护照格式错误";
			break;
		// 港澳台通行证
		case IDENTITY_TYPE_HMT_PASSER:
			// msg = ""; // todo 时间关系，暂未找到适用的港澳台校验规则，跟后端校验保持一致
			// reg = /^([A-Z]\d{6,10}(\(\w{1}\))?)$/;
			// var b = reg.test(idcard);
			// if (!b) {
			// 	reg = /^\d{8}|^[a-zA-Z0-9]{10}|^\d{18}$/; //台湾通行证
			// 	msg = reg.test(idcard) ? "" : "港澳台通行证格式错误";
			// } else {
			// 	msg = "";
			// }
			break;
		default:
			break;
	}
	return msg;
}

function checkNameFun(str){
	if (!(/^[\u4e00-\u9fa5_a-zA-Z]+$/.test(str))) {
		return false;
	}
	return true;
}

// 对城市进行分组
function groupArea(records, codeColumn) {
	codeColumn = codeColumn || "pinyinCode";
	var groupObj = {},
		firstChar = "",
		defChar = "#";
	for (var i in records) {
		if (records[i][codeColumn]) {
			records[i][codeColumn] = records[i][codeColumn].toUpperCase();
			firstChar = records[i][codeColumn][0];
			groupObj[firstChar] = groupObj[firstChar] || [];
			groupObj[firstChar].push(records[i]);
		} else {
			groupObj[defChar] = groupObj[defChar] || [];
			groupObj[defChar].push(records[i])
		}
	}
	var codes = Object.keys(groupObj);
	codes = codes.sort();
	var newData = {};
	for (var i in codes) {
		newData[codes[i]] = groupObj[codes[i]];
	}
	return newData;
}

// 时间相关
function formatDatetime(timeObj, format) {
	format = format || "YYYY-MM-DD HH:II:SS";
	var year = timeObj.getFullYear();
	var month = supliZero(timeObj.getMonth() + 1);
	var date = supliZero(timeObj.getDate());
	var hour = supliZero(timeObj.getHours());
	var minutes = supliZero(timeObj.getMinutes());
	var seconds = supliZero(timeObj.getSeconds());
	var weekDayNum = timeObj.getDay();
	var weekDay = weekDayNum ? transNum(weekDayNum) : "日";
	format = format.replace("YYYY", year);
	format = format.replace("MM", month);
	format = format.replace("DD", date);
	format = format.replace("WW", "星期" + weekDay);
	format = format.replace("HH", hour);
	format = format.replace("II", minutes);
	format = format.replace("SS", seconds);
	return format;
}

// 补零
function supliZero(num) {
	return num >= 10 ? num : "0" + num;
}
/**
 * 数字转汉字
 * @param  Number num   数字
 * @param  Boolean issup 是否大写，默认是小写
 * @param  Boolean replace 是否需要转译：二十变成廿，三十变成卅，默认不需要
 * @param  Boolean cutFirst 当第一个数字为1时，是否需要剪掉，默认不需要
 * @param  Boolean ignore 是否忽略进制，默认是小写
 * @return String       数字对应的汉字
 */
function transNum(num, issup, replace, cutFirst, ignore) {
	cutFirst = cutFirst || false;
	ignore = ignore || false;
	issup = issup || false;
	replace = replace || false;

	function divisionTen(tmpNum, ignore, issup, countDivision) {
		countDivision = countDivision || 0;
		let str = "",
			tmpStr = "",
			unitStr = "";
		let tenStr, unitStr1;
		if (issup) {
			tenStr = ["零", "壹", "貳", "叁", "肆", "伍", "陸", "柒", "捌", "玖"];
			unitStr1 = ["拾", "佰", "仟", "萬", "亿", "兆"];
		} else {
			tenStr = ["零", "一", "二", "三", "四", "五", "六", "七", "八", "九"];
			unitStr1 = ["十", "百", "千", "万", "亿", "兆"];
		}
		let intNum = parseInt(tmpNum / 10);
		let slotNum = tmpNum % 10;
		countDivision++;
		tmpStr = tenStr[slotNum];
		if (intNum > 10) {
			tmpStr = ignore ? tmpStr : unitStr1[countDivision - 1] + tmpStr;
			str = divisionTen(intNum, ignore, issup, countDivision) + tmpStr;
		} else {
			if (intNum) {
				unitStr = ignore ? tenStr[intNum] : tenStr[intNum] + unitStr1[countDivision - 1];
			}
			str = unitStr + tmpStr;
		}
		return str;
	}
	let numChars = divisionTen(num, ignore, issup);
	// 去掉第一个字符为一/壹的
	let firstChar = numChars.substr(0, 1);
	if (ignore) cutFirst = false;
	if (cutFirst && (firstChar == "一" || firstChar == "壹")) {
		numChars = numChars.substr(1);
	}
	let replaceNum = num % 100;
	if (replaceNum > 20 && replaceNum < 30 && replace) {
		numChars = numChars.replace("二十", "廿");
		numChars = numChars.replace("貳拾", "廿");
	}
	if (replaceNum > 30 && replaceNum < 40 && replace) {
		numChars = numChars.replace("三十", "卅");
		numChars = numChars.replace("叁拾", "卅");
	}
	numChars = numChars.replace("十零", "十");
	numChars = numChars.replace("拾零", "拾");
	return numChars;
}

// 将地区归类到父地区里面
function treeMenu(nodes, parentId) {
	var tree = [];
	for (var i in nodes) {
		tree.push({
			text: nodes[i].AreaName,
			value: nodes[i].areaId,
			parentId: nodes[i].parentId
		});
	}
	var groups = {};

	function group() {
		for (var i = 0; i < tree.length; i++) {
			if (groups[tree[i].parentId]) {
				groups[tree[i].parentId].push(tree[i]);
			} else {
				groups[tree[i].parentId] = [];
				groups[tree[i].parentId].push(tree[i]);
			}
		}
	}
	group();
	var levelAreas = [];
	if (groups[parentId].length) {
		for (var i in groups[parentId]) {
			groups[parentId][i].children = groups[groups[parentId][i].value];
			levelAreas.push(groups[parentId][i]);
		}
	}
	return levelAreas;
};

// 通过childId检查当前儿童是否为自建档
function checkAddBySelf(childId) {
	return childId && childId.indexOf("_CTI") > -1;
}

// 判断是否含有大写字母
function hasCapital(str) {
	return str.match(/^.*[A-Z]+.*$/);
}

// 判断是否含有小写字母
function hasLowercase(str) {
	return str.match(/^.*[a-z]+.*$/);
}

// 判断是否含有数字
function hasNumber(str) {
	return str.match(/^.*[0-9]+.*$/);
}

//DES加密
function encryptByDES(message, key){
    var keyHex = CryptoJS.enc.Utf8.parse(key);
    var encrypted = CryptoJS.DES.encrypt(message, keyHex, {
        mode: CryptoJS.mode.ECB,
        padding: CryptoJS.pad.Pkcs7
    });
    return encrypted.ciphertext.toString();
}
//DES解密
function decryptByDES(ciphertext, key){
    var keyHex = CryptoJS.enc.Utf8.parse(key);
    var decrypted = CryptoJS.DES.decrypt({
        ciphertext: CryptoJS.enc.Hex.parse(ciphertext)
    }, keyHex, {
        mode: CryptoJS.mode.ECB,
        padding: CryptoJS.pad.Pkcs7
    });
    var result_value = decrypted.toString(CryptoJS.enc.Utf8);
    return result_value;
}

// 判断是否成人
function checkAdult(birthday) {
	var result = false;
	if(birthday) {
		var birthDate = new Date(birthday).getTime();
		var currentDate = new Date();
		var eighteenBirth = new Date(currentDate.getFullYear() - 18, currentDate.getMonth(), currentDate.getDate(), 8).getTime();
		result = birthDate <= eighteenBirth;;
	}
	return result;
}

// 判断是否老龄人
function checkOlder(birthday) {
	var result = false;
	if(birthday) {
		var today = formatDatetime(new Date(), 'YYYY-MM-DD');
		var todayArr = today.split("-");
		var birthdayArr = birthday.split("-");
		if(todayArr[0] - birthdayArr[0] >= 60) {
			result = true;
		}
	}
	return result;
}